#include <iostream>

using namespace std;

int main()
{
    int n, w, a, p, k, zbir=0;
    bool b=false ;
    cin >> n >> w;
    int niz[w] ;
    for(int i=0; i<w; i++){
        niz[i]=1 ;

    }
    for(int i=0; i<n; i++){
        for(int j=0; j<w; j++){
            b=false ;
            cin >> a ;
            if(a==0){
                b=true ;
                p=j;
                while((a==0)&&(j<w-1)){
                    cin >> a ;
                    j++;
                }
                if((a==0)&&(j==w-1)){
                    k=j;
                }
                else k=j-1 ;
            }
            int q;
            zbir=0 ;
            if(b==true){
                if(p==0){

                    for(q=p; q<=k; q++){
                            zbir+=niz[q] ;
                        niz[q]=0;
                    }
                    niz[q]+=zbir ;
                }
                else{
                    if(k==w-1){
                        for(q=p; q<=k; q++){
                                zbir+=niz[q] ;
                            niz[q]=0;
                        }
                        niz[p-1]+=zbir ;
                    }
                    else{
                        if(p>0){
                            for(q=p; q<=k; q++){
                                zbir+=niz[q] ;
                                niz[q]=0;
                            }
                            niz[p-1]+=zbir/2;
                            niz[k+1]+=zbir/2;
                            if(zbir%2==1){
                                if(i%2==1){
                                    niz[k+1]++;
                                }
                                else{
                                    niz[p-1]++;
                                }
                            }
                        }

                    }
                }


            }
        }

    }
    for(int i=0; i<w; i++){
        cout << niz[i] << " " ;
    }
    return 0;
}